// Q2 108061112 林靖
// An positive integer N is said to be a perfect number if it is the sum
// of all of its proper divisors. That is,
//
// N = sum d, d < N and N % d = 0.
//
// For example, 6 is a perfect number since 6 has 3 proper divisors: 1, 2, and
// 3, and 6 = 1 + 2 + 3.
//
// Please write a C program to find first 4 perfect numbers.
// Example of program output:
// ./a.out
// Perfect number 1: 6
// ...

#include <stdio.h>

int main(void)
{
	int num;			// the number to be tested
	int count = 0;		// the number of perfect numbers found
	int div;			// the divisor
	int sum;			// the sum of divisors

	for (num = 6; count <= 4; num++) {			// find first 4 perfect numbers
		sum = 0;								// reinitialize sum of divisors
		for (div = 1; div < num; div++) {
			if (num % div == 0) {				// sum up all the divisors
				sum += div;
			}
		}
		if (sum == num) {				// if sum of the divisors == the number 
			printf("Perfect number %d: %d\n", count++, num);
		}								// the number is perfect
	}

	return 0;			// Normal program termination
}
